#include <iostream>
#include <cmath>
using namespace std;


void TooLowMsg()
{
   cout << endl
        << "Value must be bigger than 0"
        << endl;
}
double GetValue()
{
   double val;
   do {
      cout << "Enter the value: "
           << flush;
      cin >> val;
      if (val<=0.0)
         TooLowMsg();
   } while (val<=0.0);
   return val;
}

int main(int argc, char *argv[])
{
   int retval = 0;
   double val = -1.0;

   if (argc>1) {
      val = atof(argv[1]);
      if (val<=0.0)
         TooLowMsg();
   }
   if (val<=0.0)
      val = GetValue();

   cout << "The log of "
        << val 
        << " is "
        << log(val)
        << endl;

   return 0;
}